/* eslint-disable @typescript-eslint/no-empty-interface */
// Generated code for namespace: concerto.metamodel

// imports
import {IConcept} from './concerto';

// interfaces
export interface ITypeIdentifier extends IConcept {
   name: string;
   fullyQualifiedName?: string;
}

export interface IDecoratorLiteral extends IConcept {
}

export interface IDecoratorString extends IDecoratorLiteral {
   value: string;
}

export interface IDecoratorNumber extends IDecoratorLiteral {
   value: number;
}

export interface IDecoratorBoolean extends IDecoratorLiteral {
   value: boolean;
}

export interface IDecoratorTypeReference extends IDecoratorLiteral {
   type: ITypeIdentifier;
   isArray: boolean;
}

export interface IDecorator extends IConcept {
   name: string;
   arguments?: IDecoratorLiteral[];
}

export interface IIdentified extends IConcept {
}

export interface IIdentifiedBy extends IIdentified {
   name: string;
}

export interface IEnumDeclaration extends IConcept {
   name: string;
   fields: IEnumFieldDeclaration[];
}

export interface IEnumFieldDeclaration extends IConcept {
   name: string;
   decorators?: IDecorator[];
}

export interface IClassDeclaration extends IConcept {
   name: string;
   decorators?: IDecorator[];
   isAbstract: boolean;
   identified?: IIdentified;
   superType?: ITypeIdentifier;
   fields: IFieldDeclaration[];
}

export interface IAssetDeclaration extends IClassDeclaration {
}

export interface IParticipantDeclaration extends IClassDeclaration {
}

export interface ITransactionDeclaration extends IClassDeclaration {
}

export interface IEventDeclaration extends IClassDeclaration {
}

export interface IConceptDeclaration extends IClassDeclaration {
}

export interface IFieldDeclaration extends IConcept {
   name: string;
   isArray: boolean;
   isOptional: boolean;
   decorators?: IDecorator[];
}

export interface IRelationshipDeclaration extends IFieldDeclaration {
   type: ITypeIdentifier;
}

export interface IObjectFieldDeclaration extends IFieldDeclaration {
   defaultValue?: string;
   type: ITypeIdentifier;
}

export interface IBooleanFieldDeclaration extends IFieldDeclaration {
   defaultValue?: boolean;
}

export interface IDateTimeFieldDeclaration extends IFieldDeclaration {
}

export interface IStringFieldDeclaration extends IFieldDeclaration {
   defaultValue?: string;
   validator?: IStringRegexValidator;
}

export interface IStringRegexValidator extends IConcept {
   regex: string;
}

export interface IDoubleFieldDeclaration extends IFieldDeclaration {
   defaultValue?: number;
   validator?: IDoubleDomainValidator;
}

export interface IDoubleDomainValidator extends IConcept {
   lower?: number;
   upper?: number;
}

export interface IIntegerFieldDeclaration extends IFieldDeclaration {
   defaultValue?: number;
   validator?: IIntegerDomainValidator;
}

export interface IIntegerDomainValidator extends IConcept {
   lower?: number;
   upper?: number;
}

export interface ILongFieldDeclaration extends IFieldDeclaration {
   defaultValue?: number;
   validator?: ILongDomainValidator;
}

export interface ILongDomainValidator extends IConcept {
   lower?: number;
   upper?: number;
}

export interface IImport extends IConcept {
   namespace: string;
   uri?: string;
}

export interface IImportAll extends IImport {
}

export interface IImportType extends IImport {
   name: string;
}

export interface IModelFile extends IConcept {
   namespace: string;
   imports?: IImport[];
   enumDeclarations?: IEnumDeclaration[];
   classDeclarations?: IClassDeclaration[];
}

